//+------------------------------------------------------------------+
//|                                                OneDailyTrade.mq4 |
//|                                    Base on holyguy7 trading plan |
//|                                       Copyright  2006, firedave | 
//|                    Partial Function Copyright  2006, codersguru | 
//|                        Partial Function Copyright  2006, pengie | 
//|                                        http://www.fx-review.com/ | 
//|                                        http://www.forex-tsd.com/ | 
//+------------------------------------------------------------------+

/*--------------------------------------------------------------------

    Modification History
    --------------------
    1.1    07/19/2006    Add TrailingStop stuff
    1.3    08/02/2006    Add PipStep feature
    

  --------------------------------------------------------------------*/
  
#property copyright "Copyright  2006, firedave"
#property link      "http://www.fx-review.com"

//+------------------------------------------------------------------+
//| INCLUDES FILES                                                   |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| EXPERT ADVISOR EXTERN VARIABLE                                   |
//+------------------------------------------------------------------+
extern string  
         Expert_Name       = "---------- OneDailyTrade";
extern int
         MagicN            = 1234; 
extern double 
         StopLoss          = 40,
         TakeProfit        = 40;

extern bool  
         bCloseOnlyOppositeOrders = true,
         bCheckConditionsOnPipstep = true;

extern int    
         TSActivation = 30,
         TrailPips =  10,
         BrokerMinTrailPips =   5;
         
extern string  
         PipStep_Setting   = "---------- PipStep Setting";
extern int
         PipStep           = 15,
         MaxTrade          = 3;

extern string  
         GMT_Setting       = "---------- GMT Setting";
extern int
         ZeroGMT           = 18,
         MinuteLimit       = 60,
         HourRange         = 20,
         StartDay          = 1,
         EndDay            = 5;
//         BrokerGMTOffset   = 2;    // MIG is 2.  Interbank FX and GMT are 0. FXDD is 3

extern string  
         Order_Setting     = "---------- Order Setting";
extern int
         NumberOfTries     = 5,
         Slippage          = 5;
extern int
         ReverseEntry      = 0;

extern string  
         MM_Parameters     = "---------- Money Management";
extern double 
         Lots              = 1;
extern bool 
         MM                = false, //Use Money Management or not
         AccountIsMicro    = false; //Use Micro-Account or not
extern int 
         Risk              = 5; //10%
extern string  
         Testing_Parameters= "---------- Back Test Parameter";
extern bool
         PrintControl      = false;         

extern bool bPlaySounds = false;

//+------------------------------------------------------------------+
//| EXPERT ADVISOR PROGRAM SETTING AND GLOBAL VARIABLES              |
//+------------------------------------------------------------------+
bool
         GenerateMagicN    = true,
         UseNewDate        = true,
         AllowTrade        = true;
string
         TimeFilterOn      = "ALL",
         TicketComment,
         TicketC           = "OneDailyTradeEA",
         LastTrade;         
static int
         MagicNumber,
         TimeFrame         = 0,
         TradeDate;
datetime
         CheckValueTime;
double 
         PreviousOpen,
         CurrentOpen;
int   
         iSL, iTP,
         PipStepCycle;
bool
         BuyCondition,
         SellCondition;


//+------------------------------------------------------------------+
//| EXPERT ADVISOR ADDITIONAL GLOBAL VARIABLES                       |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| INITIALIZATION FUNCTION                                          |
//+------------------------------------------------------------------+
int init()
{
//+------------------------------------------------------------------+
//| BUILD MAGIC NUMBER AND TICKET COMMENT                            |
//+------------------------------------------------------------------+
   if(GenerateMagicN)
   {
      MagicNumber    = subGenerateMagicNumber(MagicN, Symbol(), Period());
      TicketComment  = StringConcatenate(TicketC, "-", Symbol(), "-", Period());
   }

//+------------------------------------------------------------------+
//| CHECK LAST OPEN TRADE                                            |
//+------------------------------------------------------------------+
   LastTrade = subCheckOpenTrade();
}

//+------------------------------------------------------------------+
//| DE-INITIALIZATION FUNCTION                                       |
//+------------------------------------------------------------------+
int deinit()
{
 
//+------------------------------------------------------------------+
//| PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME               |
//+------------------------------------------------------------------+
   TimeFrame=Period(); 
   return(0);
}


//+------------------------------------------------------------------+
//| EXPERT ADVISOR START                                             |
//+------------------------------------------------------------------+
int start()
{

//+------------------------------------------------------------------+
//| EXPERT ADVISOR LOCAL VARIABLES                                   |
//+------------------------------------------------------------------+
/*   double 
         PreviousOpen,
         CurrentOpen;*/
   int   
         cnt,
         ticket,
         total;
/*         iSL, iTP;
   bool
         BuyCondition,
         SellCondition;*/
         
//+------------------------------------------------------------------+
//| CHECK CHART NEED MORE THAN 100 BARS                              |
//+------------------------------------------------------------------+
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }

//+------------------------------------------------------------------+
//| CHECK FOR NEW DAY                                                |
//+------------------------------------------------------------------+
   if(UseNewDate && TradeDate!=TimeDay(iTime(NULL,TimeFrame,0)))
   {
      TradeDate   = TimeDay(iTime(NULL,TimeFrame,0));
      AllowTrade  = true;
   }

//+------------------------------------------------------------------+
//| MAINTAIN ANY OPEN TRADE                                          |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| TRAILING STOP                                                    |
//+------------------------------------------------------------------+
   if( subOrdersTotal() > 0 )
   {
     if( PrintControl ) Print( "Processing Trailing Stops" );
     ProcessTrailingStops( );
   }

/*   if(TrailingStop>0 && subOrdersTotal()>0)
   {
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
         {
            subTrailingStop(OrderType());
         }
      }
   }                  
*/

//+------------------------------------------------------------------+
//| PIP STEP                                                         |
//+------------------------------------------------------------------+
   if(subOrdersTotal()>0 && PipStep>0 && PipStepCycle<=MaxTrade)
   {
      total       = OrdersTotal();
      
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL &&
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(subHighestLowest("BUY"))
               {
                  subCheckTradeCondition();
                  if(BuyCondition || !bCheckConditionsOnPipstep )
                  {
                     ticket        = subOpenOrder(OP_BUY,iSL,iTP,TicketComment); // open BUY order
                     subCheckError(ticket,"BUY");
                     LastTrade     = "BUY";
                     PipStepCycle++;
                  }
                  else if(SellCondition)
                  {
                     subCloseOrders( OP_BUY );
         
                     ticket        = subOpenOrder(OP_SELL,iSL,iTP,TicketComment); // open SELL order
                     subCheckError(ticket,"SELL");
                     LastTrade     = "SELL";
                     PipStepCycle++;
                  }
               }
            }
            if(OrderType()==OP_SELL)
            {
               if(subHighestLowest("SELL"))
               {
                  subCheckTradeCondition();

                  if(SellCondition || !bCheckConditionsOnPipstep )
                  {
                     ticket        = subOpenOrder(OP_SELL,iSL,iTP,TicketComment); // open SELL order
                     subCheckError(ticket,"SELL");
                     LastTrade     = "SELL";
                     PipStepCycle++;
                  }
                  else if( BuyCondition )
                  {
                     subCloseOrders( OP_SELL );

                     ticket        = subOpenOrder(OP_BUY,iSL,iTP,TicketComment); // open BUY order
                     subCheckError(ticket,"BUY");
                     LastTrade     = "BUY";
                     PipStepCycle++;
                  }
               }
            }
         }
      }
   }

//+------------------------------------------------------------------+
//| ENTRY CONDITION                                                  |
//+------------------------------------------------------------------+
   if(!AllowTrade) return(0);
   
   if( PrintControl ) Print( "Day is correct, Hour=" + Hour( ) + ", Minute="+ Minute( ) );
   
   if(TimeDayOfWeek(CurTime())>=StartDay &&
      TimeDayOfWeek(CurTime())<=EndDay &&
      ( Hour() == ZeroGMT && Minute() <= MinuteLimit ))
   {
/*      PreviousOpen = iOpen(NULL,TimeFrame,iBarShift(NULL,TimeFrame,iTime(NULL,TimeFrame,0)-HourRange*3600));
      CurrentOpen  = iOpen(NULL,TimeFrame,0);
            
      if(!ReverseEntry)
      {
         BuyCondition  = (CurrentOpen>PreviousOpen);
         SellCondition = (CurrentOpen<PreviousOpen);
         iSL = StopLoss;
         iTP = TakeProfit;
      }
      else
      {
         SellCondition = (CurrentOpen>PreviousOpen);
         BuyCondition  = (CurrentOpen<PreviousOpen);
         iSL = TakeProfit;
         iTP = StopLoss;
      }

      if( PrintControl ) Print( "PreviousOpen=" + PreviousOpen + ", CurrentOpen=" + CurrentOpen + ", BuyCond="+BuyCondition+", SellCond=" + SellCondition );

      //if(PrintControl) Print(PreviousOpen," - ",CurrentOpen);*/
      subCheckTradeCondition();
      
//+------------------------------------------------------------------+
//| CLOSE ANY TRADE                                                  |
//+------------------------------------------------------------------+
     if( !bCloseOnlyOppositeOrders )
      subCloseAllOrders( );
   }
      
//+------------------------------------------------------------------+
//| ADJUST LOTS IF USING MONEY MANAGEMENT                            |
//+------------------------------------------------------------------+
   if(MM) Lots = subLotSize();

//+------------------------------------------------------------------+
//| NEW TRADE - ENTRY                                                |
//+------------------------------------------------------------------+
   if(subOrdersTotal()<1 && (BuyCondition || SellCondition)) 
   {

//+------------------------------------------------------------------+
//| OPEN BUY ORDER                                                   |
//+------------------------------------------------------------------+
      if(BuyCondition)
      {
         subCloseOrders( OP_SELL );

         ticket        = subOpenOrder(OP_BUY,iSL,iTP,TicketComment); // open BUY order
         subCheckError(ticket,"BUY");
         LastTrade     = "BUY";
         PipStepCycle  = 1;
      }

//+------------------------------------------------------------------+
//| OPEN SELL ORDER                                                  |
//+------------------------------------------------------------------+
      if(SellCondition)
      {
         subCloseOrders( OP_BUY );
         
         ticket        = subOpenOrder(OP_SELL,iSL,iTP,TicketComment); // open SELL order
         subCheckError(ticket,"SELL");
         LastTrade     = "SELL";
         PipStepCycle  = 1;
      }
      
      AllowTrade = false;
   }

//+------------------------------------------------------------------+
//| IF THERE IS NOTHING ELSE GO TO START                             |
//+------------------------------------------------------------------+
   return(0);
}

//+------------------------------------------------------------------+
//| END PROGRAM                                                      |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| FUNCTION DEFINITIONS                                             |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| FUNCTION : MONEY MANAGEMENT                                      |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
double subLotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM < 0.1)                  lotMM = Lots;
	     if((lotMM > 0.5) && (lotMM < 1)) lotMM = 0.5;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  else //micro account
	  {
	     if(lotMM < 0.01)                 lotMM = Lots;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}

//+------------------------------------------------------------------+
//| FUNCTION : NUMBER OF ORDER BASE ON SYMBOL AND MAGIC NUMBER       |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subOrdersTotal()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK OPEN ORDER BASE ON SYMBOL AND MAGIC NUMBER      |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
string subCheckOpenTrade()
{
   int
      cnt         = 0;
   string
      lasttrade   = "None";      

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY ) lasttrade = "BUY";
         if(OrderType()==OP_SELL) lasttrade = "SELL";
      }         
   }
   return(lasttrade);
}

//+------------------------------------------------------------------+
//| FUNCTION : OPEN ORDER                                            |
//| SOURCE   : CODERSGURU, PENGIE                                    |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subOpenOrder(int type, int mStopLoss, int mTakeProfit, string mTicketComment)
{
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(mStopLoss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-mStopLoss*Point,4);
      bStopLoss   = NormalizeDouble(Bid+mStopLoss*Point,4);
   }
   
   if(mTakeProfit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+mTakeProfit*Point,4);
      bTakeProfit = NormalizeDouble(Bid-mTakeProfit*Point,4);
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,aStopLoss,aTakeProfit,mTicketComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,bStopLoss,bTakeProfit,mTicketComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }  
   return(ticket);
}


void subCloseAllOrders( )
{
  subCloseOrders( OP_BUY  );
  subCloseOrders( OP_SELL );
}


//+------------------------------------------------------------------+
//| FUNCTION : CLOSE ORDER                                           |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
void subCloseOrders( int iDirection )
{
   int
      cnt, 
      total = 0;

   total = OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber &&
         ( OrderType( ) == iDirection )
        )
      {
         switch(OrderType())
         {
            case OP_BUY      :
               OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
               break;
               
            case OP_SELL     :
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
               break;
         }
      }
   }      
}

//+------------------------------------------------------------------+
//| FUNCTION : TRAILING STOP                                         |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
/*void subTrailingStop(int Type)
{
   if(Type==OP_BUY)   // buy position is opened   
   {
      if(Bid-OrderOpenPrice()>Point*TrailingStop &&
         OrderStopLoss()<Bid-Point*TrailingStop)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
         return(0);
      }
   }

   if(Type==OP_SELL)   // sell position is opened   
   {
      if(OrderOpenPrice()-Ask>Point*TrailingStop)
      {
      if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
         return(0);
      }
      }
   }
}
*/

//+------------------------------------------------------------------+
//| FUNCTION : CHECK ERROR CODE                                      |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : n/a                                                   |
//+------------------------------------------------------------------+
void subCheckError(int ticket, string Type)
{
   if(ticket>0) 
   {
//      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(Type + " order opened : ",OrderOpenPrice());
   }
   else Print("Error opening " + Type + " order : ", ErrorDescription(GetLastError()));
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK TRADE CONDITION                                 |
//| SOURCE   : FIREDAVE                                              |
//| MODIFIED : n/a                                                   |
//+------------------------------------------------------------------+
void subCheckTradeCondition()
{
   PreviousOpen  = iOpen(NULL,TimeFrame,iBarShift(NULL,TimeFrame,iTime(NULL,TimeFrame,0)-HourRange*3600));
   CurrentOpen   = iOpen(NULL,TimeFrame,0);
   BuyCondition  = false;
   SellCondition = false;
            
   if(!ReverseEntry)
   {
      BuyCondition  = (CurrentOpen>PreviousOpen);
      SellCondition = (CurrentOpen<PreviousOpen);
      iSL = StopLoss;
      iTP = TakeProfit;
   }
   else
   {
      SellCondition = (CurrentOpen>PreviousOpen);
      BuyCondition  = (CurrentOpen<PreviousOpen);
      iSL = TakeProfit;
      iTP = StopLoss;
   }

   if( PrintControl ) Print( "PreviousOpen=" + PreviousOpen + ", CurrentOpen=" + CurrentOpen + ", BuyCond="+BuyCondition+", SellCond=" + SellCondition );
}

//+------------------------------------------------------------------+
//| FUNCTION : FIND LOWEST/HIGHEST BUY-SELL FUNCTION                 |
//| SOURCE   : FIREDAVE                                              |
//| MODIFIED : n/a                                                   |
//+------------------------------------------------------------------+
bool subHighestLowest(string type)
{
   int
      cnt, 
      total = 0;
      
   double
      HighestBuy  = 0,
      LowestBuy   = 10000,
      HighestSell = 0,
      LowestSell  = 10000;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(OrderOpenPrice()<LowestBuy ) LowestBuy  = OrderOpenPrice();
            if(OrderOpenPrice()>HighestBuy) HighestBuy = OrderOpenPrice();
         }

         if(OrderType()==OP_SELL)
         {
            if(OrderOpenPrice()<LowestSell ) LowestSell  = OrderOpenPrice();
            if(OrderOpenPrice()>HighestSell) HighestSell = OrderOpenPrice();
         }

      }
   }
   
   if     (type=="BUY"  && (Bid - LowestBuy   <= -PipStep*Point)) return(true);
   else if(type=="SELL" && (HighestSell - Ask <= -PipStep*Point)) return(true);
   else return(false);
}

//+------------------------------------------------------------------+
//| FUNCTION : GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME   |
//| SOURCE   : PENGIE                                                |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
        if (symbol == "EURUSD")  isymbol = 10;
   else if (symbol == "GBPUSD")  isymbol = 20;
   else if (symbol == "USDJPY")  isymbol = 30;
   else if (symbol == "USDCHF")  isymbol = 40;
   else if (symbol == "AUDUSD")  isymbol = 50;
   else if (symbol == "USDCAD")  isymbol = 60;
   else if (symbol == "EURGBP")  isymbol = 11;
   else if (symbol == "EURJPY")  isymbol = 12;
   else if (symbol == "EURCHF")  isymbol = 13;
   else if (symbol == "EURAUD")  isymbol = 14;
   else if (symbol == "EURCAD")  isymbol = 15;
   else if (symbol == "GBPJPY")  isymbol = 21;
   else if (symbol == "GBPCHF")  isymbol = 22;
   else if (symbol == "GBPAUD")  isymbol = 23;
   else if (symbol == "GBPCAD")  isymbol = 24;
   else                          isymbol = 99;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
}

//+------------------------------------------------------------------+
//| END FUNCTION                                                     |
//+------------------------------------------------------------------+






// Trailing Stop stuff
#define TS_MAX 20
#define TS_GAP_BEFORE_MODIFY 5
int         tsTicket[TS_MAX];
double      tsPrice[TS_MAX];
bool        tsActive[TS_MAX];

void ProcessTrailingStops( )
{
  if( TrailPips == 0 )
   return( 0 );
   
  bool bSoundPlayed = false;
  bool bOrderClosed = true;
  int  iBrokerTrailPips = MathMax( TrailPips, BrokerMinTrailPips );
  double dBrokerTrailPips = ND( iBrokerTrailPips * Point );
  double dTrailPips = ND( TrailPips*Point );
  double dTSActivation = ND( TSActivation * Point );

  for( int i = OrdersTotal()-1; i >= 0; i-- )
  {
    double dNewStop = 0.0;
    double dNewBrokerStop = 0.0;
    double dProposedStop = 0.0;
    
    OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
    
    if( OrderSymbol()==Symbol() &&
        OrderMagicNumber()==MagicNumber )
    { 
      LogWrite( "Processing Trailing Stops for ticket#" + OrderTicket( ), false );

      //Pulls in order that meets the criteria for processing
      int pos = -1;
        
      for( int b = 0; b < TS_MAX; b++ ) // this (loopB) compares the ticket# of the selected order against the number stored in the ticket array
       if( tsTicket[b] == OrderTicket( ))
       {
         pos=b;// if ticket numbers match, pos is the position in the array where the trailing data is stored
   
         break;
       }

      if( pos == -1 )
      { // if the loopB did not find a matching ticket number it is time to initialize the data
        pos = 0;
          
        for( int j = 0; j < TS_MAX; j++ )
         if( tsTicket[j] == 0 )
         {// this is looking for the earliest instance within the array to store the data
           pos=j;
           break;
         }

        LogWrite( "Order NOT found in array, adding at position #" + pos, false );
          
        tsTicket[pos] = OrderTicket();// setting the ticket number
        tsActive[pos] = false;// this is to determine when trailing kicks in
      }
      else
       LogWrite( "Order found in array at position #" + pos, false );



      // Now, check to see if the TS should be moved
      if( OrderType( ) == OP_SELL )
      {
        dProposedStop = ND( Ask + dTrailPips );
        
        LogWrite( "Processing TS for SELL order: tsActive:"+tsActive[pos]+",OrderOpenPrice(): " + DtS( OrderOpenPrice()) + ", Ask:" + DtS( Ask ) + ", TSA:" + DtS( dTSActivation ), false );
        // Check to see if we've hit the TSActivation point

        if( !tsActive[pos] && 
           (( dTSActivation == 0.0 ) && (( Ask + dTrailPips ) <= OrderOpenPrice( ) )) ||
           (( ND( OrderOpenPrice() - Ask ) >= dTSActivation )
           )
          )
        { 
          tsPrice[pos] = dProposedStop;// this is the new trailing stop price
          dNewStop = tsPrice[pos];
          tsActive[pos] = true;// it's ok to proceed with trailing stop
          LogWrite( "Order now active with trailing stop of " + DtS( tsPrice[pos] ), false );
        }

        // Time to move the Trailing Stop again!
        if( tsActive[pos] && ( dProposedStop < tsPrice[pos] ))
        {
          tsPrice[pos] = dProposedStop;
          dNewStop = tsPrice[pos];
          LogWrite( "Order already active, new TS is " + DtS( tsPrice[pos] ), false );
        }

        if( Ask >= ND( OrderStopLoss( ) + (( BrokerMinTrailPips + TS_GAP_BEFORE_MODIFY ) * Point )))
         dNewBrokerStop = ND( Ask + dBrokerTrailPips );

        if( tsActive[pos] && Ask >= tsPrice[pos] )
        { // if the postion hits the stop price
          OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
          bOrderClosed = true;
          LogWrite("Short Order "+tsTicket[pos]+" Closed from TS", true);
        }
      }
        
      if( OrderType( ) == OP_BUY )
      { 
        dProposedStop = ND( Bid - dTrailPips );
      
        LogWrite( "Processing TS for BUY order:  tsActive:"+tsActive[pos]+",OrderOpenPrice(): " + DtS( OrderOpenPrice()) + ", Bid:" + DtS( Bid ) + ", TSA:" + DtS( dTSActivation ), false );
        
        if( !tsActive[pos] && 
           (( dTSActivation == 0.0 ) && (( Bid - dTrailPips ) >= OrderOpenPrice( ) )) ||
           (( ND( Bid - OrderOpenPrice() ) >= dTSActivation )
           )
          )
        { 
          tsPrice[pos] = dProposedStop;
          dNewStop = tsPrice[pos];
          tsActive[pos]=true;
          LogWrite( "Order now active with trailing stop of " + DtS( tsPrice[pos] ), false );
        }

        if( tsActive[pos] && ( dProposedStop > tsPrice[pos] ))
        {
          tsPrice[pos] = dProposedStop;
          dNewStop = tsPrice[pos];
          LogWrite( "Order already active, new TS is " + tsPrice[pos], false );
        }

        if( Bid <= ND( OrderStopLoss( ) - (( BrokerMinTrailPips - TS_GAP_BEFORE_MODIFY ) * Point )))
         dNewBrokerStop = Bid - dBrokerTrailPips;

        if( tsActive[pos] && ( Bid <= tsPrice[pos] ))
        {
          OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
          bOrderClosed = true;
          LogWrite("Long Order "+tsTicket[pos]+" Closed from TS", true);
        }
      }

      if( dNewStop != 0.0 )
      {   
        if( bPlaySounds && !bSoundPlayed )       
        {
          PlaySound( "stops.wav" );
          bSoundPlayed = true;
        }

        LogWrite( "dNewStop="+ dNewStop, true );
            
        // if this distance from the current price to the new stop, then actually modify the order.
        if( dNewBrokerStop != 0.0 )
        {
          OrderModify( OrderTicket(), OrderOpenPrice(), dNewBrokerStop, OrderTakeProfit(), 0, Pink );
            
          LogWrite( "dNewBrokerStop=" + dNewBrokerStop, true );
        }
      }
    }
  }

  if( bOrderClosed )
  {
    for( i = 0; i < TS_MAX; i++ )
    { // this searches the array for ticket numbers that are now obsolete due to an order that has closed
      if( tsTicket[i] > 0 )
      {
        bool found=false;
        for( b = 0; b < OrdersTotal( ); b++ )
        {
          OrderSelect( b, SELECT_BY_POS );

          if( tsTicket[i] == OrderTicket( ))
          {
            found=true;
            break;
          }
        }

        if( !found )
        { // if there are matching ticket numbers in the trade pool and the array then nothing happens
          tsTicket[i] = 0;
          tsPrice [i] = 0;
          tsActive[i] = false;// if there is an obolete ticket the the data is reset.  And the next new ticket data can occupy this space
        }
      }
    }
  }
}




double ND( double dCalc )
{
  return( NormalizeDouble( dCalc, Digits ));
}


string DtS( double dCalc )
{
  return( DoubleToStr( dCalc, Digits ));
}


void LogWrite( string sContent, bool bPrint )
{
/*  if( bWriteLog == 1 )
  {
    int hLog = FileOpen( ExpertName + " " + ExpertVersion + " " + Symbol( ) + ".log", FILE_WRITE | FILE_READ );
  
    if( hLog > 0 )
    { 
      string sDate = TimeToStr( LocalTime(), TIME_DATE | TIME_SECONDS );
    
      FileSeek ( hLog, 0, SEEK_END );
      FileWrite( hLog, sDate + "  " + sContent );
      FileClose( hLog );
    }
  }
*/  
  if( bPrint )
   Print( sContent );
}

